#include "engine/engine.h"
#include "engine/program/program.h"


int main() {
    Engine::Engine app;
    app.enableDebug();

    Engine::Program tl;
    Engine::Program br;

    //logicalDevice->createGraphicsPipeline("shaders/shader.vert.spv", "shaders/shader.frag.spv");
    tl.loadSPIRV("shaders/tl.vert.spv", Engine::Program::vertex);
    tl.loadSPIRV("shaders/shader.frag.spv", Engine::Program::fragment);

    br.loadSPIRV("shaders/br.vert.spv", Engine::Program::vertex);
    br.loadSPIRV("shaders/shader.frag.spv", Engine::Program::fragment);

    app.addProgram(tl);
    app.addProgram(br);

    try {
        app.run();
    } catch (const std::exception& e) {
        std::cerr << e.what() << std::endl;
        return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}

